#ifndef io3_H_included
#define io3_H_included 0

#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>

typedef struct {
    FILE *io3_file;
    struct timeval io3_timeout;
    unsigned io3_flag_has_timeout:1;
} io3;

io3 * io3_fdopen(int fd, const char *flags);
void io3_close(io3 *);
void io3_set_timeout(io3 *, const struct timeval *);
ssize_t io3_write(io3 *, const void *, size_t);
int io3_timed_out(io3 *);
ssize_t io3_fngets(io3 *, char *, size_t, int *);
int io3_tv_compare(const struct timeval *, const struct timeval *);
void io3_tv_sub3(const struct timeval *, const struct timeval *, struct timeval *);

#undef  io3_H_included
#define io3_H_included 1
#endif
