/*-
 * Copyright (c) 1999 Valentin Nechayev <netch@lucky.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$NetchId: nuxres.h,v 1.1 2000/11/04 18:16:21 netch Exp $
 */
#ifndef nuxres_H_included
#define nuxres_H_included 0

typedef struct {
    unsigned short Prec;
    char *Server;
} ND_MxInfo;

typedef struct {
    char *PrimaryNS;
    char *ZoneMaster;
    unsigned long Serial, Refresh, Retry, Expiry, Minimum;
} ND_SoaInfo;

/*     Data   ND_UR.    DataType */

#define NDDT_RAW        1
#define NDDT_SPECIFIC   2

/* One unpacked record */

typedef struct ND_UR {
    struct ND_UR *NextRec;
    char *Name;
    unsigned short Type;
    unsigned short Class;
    unsigned long Ttl;
    unsigned short Section;
    unsigned short DataType;
    union {
	struct {
	    unsigned Ofs;
	    unsigned  Len;
	} Raw;	/*  Raw      */
	unsigned long Addr4;	/* in host order */
	ND_MxInfo *MX;
	char *NS;
	char *Ptr;
	char *Cname;
	ND_SoaInfo *SOA;
    } Data;
} ND_UR;

typedef struct {
    unsigned rcode;
    ND_UR *Records;
} ND_Unpacked;

#define   NDERR_GENERIC   -1
#define   NDERR_NOMEM     -2
#define   NDERR_BADDATA   -3
#define   NDERR_SOFTWARE  -4

void ND_Unpacked_Free(ND_Unpacked *U);
void ND_UR_Free(ND_UR *UR);
ND_Unpacked *ND_Unpack(int *ierp, const unsigned char *Packed, size_t PackedSize);

#undef  nuxres_H_included
#define nuxres_H_included 1
#endif
