#include <unistd.h>
#include <stdio.h>
#include <err.h>
#include <string.h>
#include <stdlib.h>
#include "verify.h"
#include "mcom.h"

int
main(int argc, char *argv[])
{
    const char     *MapPath = NULL;
    struct address_entry *a;
    int             rc, opt;
    int             f_i = 0;
    while ((opt = getopt(argc, argv, "im:")) != -1) {
	switch (opt) {
	case 'i':
	    f_i = 1;
	    break;
	case 'm':
	    MapPath = optarg;
	    break;
	}
    }
    argc -= optind;
    argv += optind;
    verify_init(MapPath);
    if (!f_i) {
	if (argc < 1)
	    errx(1, "usage");
	rc = verify_address(argv[0], &a);
	fprintf(stderr, "verify_address()->%d\n", rc);
	if (a) {
	    if (!TAILQ_EMPTY(&a->ace_mmsg)) {
		struct ml_entry *e;
		fprintf(stderr, "cclass: %d\n", a->ace_cclass);
		TAILQ_FOREACH(e, &a->ace_mmsg, mle_link)
		    fprintf(stderr, "msg: %s\n", e->mle_text);
	    } else
		fprintf(stderr, "cclass: %d\nmsg: %s\n", a->ace_cclass, a->ace_msg);
	    address_entry_free(a);
	} else
	    fprintf(stderr, "a==NULL\n");
	return 0;
    }
    /* Interactive case */
    for (;;) {
	char            buf[1000];
	char           *p;
	char           *p2;
	size_t          n1;
	printf("\n>");
	fflush(stdout);
	if (!fgets(buf, sizeof buf, stdin))
	    break;
	p = strchr(buf, '\n');
	if (!p)
	    errx(1, "too long input line");
	*p = 0;
	p = buf;
	p += strspn(p, " \t\r\n");
	if (!*p)
	    continue;
	n1 = strcspn(p, " \t\r\n");
	p2 = p + n1;
	p2 += strspn(p2, " \t\r\n");
	if (*p == 't') {
	    if (!*p2) {
		fprintf(stderr, "syntax error\n");
		continue;
	    }
	    rc = verify_address(p2, &a);
	    fprintf(stderr, "verify_address()->%d\n", rc);
	    if (a) {
		fprintf(stderr, "cclass: %d\nmsg: %s\n", a->ace_cclass, a->ace_msg);
		address_entry_free(a);
	    } else
		fprintf(stderr, "a==NULL\n");
	} else
	    printf("What?");
    }
    if (ferror(stdin))
	errx(1, "ferror(stdin)");
    return 0;
}
