#ifndef verify_H_included
#define verify_H_included 0

#include <sys/types.h>
#include "tailq.h"
#include "avltree.h"

#define MAXADDRLEN 1024
#define AVL_REC_LEN (sizeof(AVL_IX_REC)+MAXADDRLEN+11)

typedef struct {
	char*			env_from;	/* envelope-from address */
	struct address_entry*	ace;	/* result of sender verify callout */
	unsigned long		relay;	/* AF_INET address */
} Priv;


struct ml_entry {
    TAILQ_ENTRY(ml_entry) mle_link;
    char *mle_text;
};

struct address_entry {
    unsigned ace_magic;
    TAILQ_ENTRY(address_entry) ace_link;
    char *ace_addr;
    int ace_cclass;	/* 2, 4, 5 */
    time_t ace_time;
    time_t ace_expire;
    char *ace_msg;
    TAILQ_HEAD(, ml_entry) ace_mmsg;
    unsigned ace_verified:1;
};

#define ACE_MAGIC 0x09ff56cc

extern int bestmxonly;		/* use only best mx */
extern int notnullrevrej;	/* reject sender if called host rejected
				   null reverse-path */

void verify_init(const char *);
int verify_address(char *, struct address_entry **);
void address_entry_free(struct address_entry *);
int check_extmap(char *, unsigned long);

#undef  verify_H_included
#define verify_H_included 1
#endif
